 /* note: link ssetargv.obj if you want to use wildcards */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

long	curoffset = 0;
char	tmpcmd[] = "_tmpxxxx.com";
char	defdat[] = "dshar.dat";

char	strbegin1[] = "\
echo off\r\n\
: This is a command.com archive, meaning:\r\n\
:   1. Remove everything above the 'echo off' line.\r\n\
:   2. Save the resulting text in a batch file (XXXX.bat).\r\n\
:   3. Execute the batch file to create:\r\n\
";

char	strbegin2[] = "\
: Existing files will NOT be overwritten unless '-c' option is specified.\r\n\
: This archive created: %s\r\n\
echo making extractor...\r\n\
";

char	strheader1[] = "\
\r\n\
if NOT EXIST %s goto %s0~\r\n\
if \"%%1\" == \"-c\" goto %s0~\r\n\
echo File already exists: skipping '%s'\r\n\
goto %s1~\r\n\
:%s0~\r\n\
echo extracting %s\r\n\
";

char	strheader2[] = "\
%s :%lx < %%0.bat > %s\r\n\
:*\r\n\
";

char	strtrailer[] = "\
:~\r\n\
if ERRORLEVEL 1 goto zzzzzzy~\r\n\
:%s1~\r\n\
";

char	strend[] = "\
\r\n\
goto zzzzzzz~\r\n\
:zzzzzzy~\r\n\
echo Failed to write file\r\n\
:zzzzzzz~\r\n\
del %s\r\n\
:You may put any additional commands to be executed here\r\n\
";

void	diskfull()
{
	fputs("write size mismatch. (disk full?)\n", stderr);
	exit(1);
}

char	*strtime()
{
	long	t;

	time(&t);
	return ctime(&t);
}

void	dosname(s)
register char	*s;
{
	register char	*p, flg = 0;

	for(p = s; *p; p++){
		if(!isascii(*p)) flg = 1;
		if(*p == '/') *p = '\\';
	}
	if(flg) return;
	for(p = s; *p; p++){
		if(isupper(*p)) *p = tolower(*p);
	}
}

void	encode(f)
register FILE	*f;
{
#define ISIZE (15 * 3)
#define OSIZE (15 * 4)
#define COUNT 1024 / ISIZE + 1
	char	ibuf[ISIZE], obuf[OSIZE + 2];
	register char	*p, *q, c;
	int	ilen, olen, count = 0;

	*obuf = ':';
	while(ilen = fread(ibuf, 1, ISIZE, f)){
		if(!(count--)) (putc('.', stderr), count = COUNT - 1);
		olen = ilen * 4 / 3 + 3;
		if(ilen % 3) (olen++, ibuf[ilen] = '\0');
		for(p = ibuf, q = obuf; ilen > 0; ilen -= 3){
			c = (*p >> 2) & 0x3f;
			c += (char)(c ? 0x20 : 0x60);
			*++q = c;

			c = (*p++ & 0x3) << 4;
			c |= (*p >> 4) & 0xf;
			c += (char)(c ? 0x20 : 0x60);
			*++q = c;

			c = (*p++ & 0xf) << 2;
			c |= (*p >> 6) & 0x3;
			c += (char)(c ? 0x20 : 0x60);
			*++q = c;

			c = (*p++ & 0x3f);
			c += (char)(c ? 0x20 : 0x60);
			*++q = c;
		}
		(obuf - 2)[olen] = '\r';
		(obuf - 1)[olen] = '\n';
		if(olen != fwrite(obuf, 1, olen, stdout)) diskfull();
		curoffset += (long)olen;
	}
	putc('\n', stderr);
}

void	makemkdir(name) /* path delimiter must be '\\' */
register char	*name;
{
	register char	*p;

	if(NULL == (p = strchr(name, ':'))) p = name; else p++;
	while(NULL != (p = strchr(++p, '\\'))){
		curoffset += (long)printf("if NOT EXIST %.*s\\*.* %s %.*s\r\n",
		       p - name, name, p[-1] & 0x80 ? "mkdir" : tmpcmd,
		       p - name, name);
	}
}

isdir(name)
register char	*name;
{
	struct	stat	statbuf;

	return(0 == stat(name, &statbuf) &&
	       S_IFDIR == (statbuf . st_mode & S_IFMT));
}

void	arc(name)
char	*name;
{
	static	char	strcnt[] = "aaaaaa";
	register char	*p, *namebuf;
	register FILE	*f;

	if(NULL == (namebuf = strdup(name))) (perror(NULL), exit(1));
	dosname(namebuf);
	if(NULL == (f = fopen(namebuf, "rb"))) (perror(namebuf), exit(1));
	fprintf(stderr, "Saving %s\t", namebuf); /* No CR */
	curoffset += (long)printf(strheader1, namebuf, strcnt, strcnt,
	       namebuf, strcnt, strcnt, namebuf);
	makemkdir(namebuf);
	fflush(stdout);
	curoffset += (long)printf(strheader2, tmpcmd, curoffset, namebuf);
	encode(f);
	curoffset += (long)printf(strtrailer, strcnt);
	fclose(f);
	free(namebuf);
	for(p = strcnt; *p; p++) if(++*p <= 'z') break; else *p = 'a'; 
}

void	usage(com)
register char	*com;
{
	fprintf(stderr, "Usage: %s FILE FILE... > ARCHIVE.bat\n", com);
	exit(1);
}

void	makeextr(com)
register char	*com;
{
#define MAXLEN 80
	register char	*p, flg = 0;
	char	buf[MAXLEN];
	FILE	*dat;

	if(NULL == (com = strdup(com))) (perror(NULL), exit(1));
	p = com + (strlen(com) - 4);
	if(p < com || strcmp(p, ".EXE")) p = defdat;
	 else p = (strcpy(p, ".dat"), com);
	if(NULL == (dat = fopen(p, "r"))) (perror(p), exit(1));
	while(NULL != fgets(buf, MAXLEN, dat)){
		p = buf + strlen(buf) - 1;
		if(buf <= p && *p == '\n') *p = '\0';
		curoffset += (long)printf("echo %s>%s %s\r\n",
			buf, flg ? ">" : "", tmpcmd);
		flg = 1;
	}
	fclose(dat);
	free(com);	
}

void	main(ac, av)
register int	ac;
register char	*av[];
{
	char	*com = *av;
	int	flg = 0;

	ac--, av++;
	if(!ac) usage(com);
	setmode(1, O_BINARY);
	fseek(stdout, 0L, 0); /* just in case... */
	for(; ac; ac--, av++){
		if(isdir(*av)){
			fprintf(stderr, "%s: directory\n", *av);
			continue;
		}
		if(!flg){
			curoffset += (long)printf(strbegin1);
			 /* here flg == 0, ac != 0 */
			for(; flg < ac; flg++){
				if(!isdir(av[flg])) curoffset += 
					(long)printf(":\t%s\r\n", av[flg]);
			}
			curoffset += (long)printf(strbegin2, strtime());
			makeextr(com);
		}
		arc(*av);
	}
	if(!flg) exit(0);
	curoffset += (long)printf(strend, tmpcmd);
	fflush(stdout);
	if(curoffset != ftell(stdout)) diskfull();
	exit(0);
}
